#include <Wire.h>       // Para a EEPROM 24LC256 DS1621 DS1307 e dispositivos i2c

#define HORAS 2         // So os mesmos valores que esto definidos no ficheiro ds1307.pde, os de offset
#define MINUTOS 1
#define SEGUNDOS 0   
#define DIASEMANA 3     // QUAL  O MELHOR NMERO? :D
#define DIAMES 4  
#define MES 5 
#define ANO 6 

#define SCE   7
#define RES   6
#define DC    5
#define SDI   4
#define SCK   3
#define backLIGHT 13

void initlcd(void);		    // Inicia o LCD.
void writecom(char);		// Escreve o comando/comandos.
void writedata(char);		// Escreve os dados para a DDRAM para iluminar os pixeis.
void clockdata(char);		// Envia os dados para o controlador PCD8544.
void clearram(void);		// Apaga o conteudo da DDRAM.
void apagarLinha(int);          // Apaga a uma linha do LCD.
void cursorxy(char,char);	// Posiciona o cursor em x,y.
void putchar(char);	        // Escreve um caracter.
void putcharInv(char);	        // Escreve um caracter com as cores inversas.
void putstr(const char *);      // Escreve um conjunto de caracteres.
void putstrInv(const char *);   // Escreve um conjunto de caracteres com as cores inversas.

void setup(void){
  Serial.begin(9600);   // Valor pequeno mas bom, eu gosto assim :D
  Wire.begin();         // Iniciar ligaes i2c - IMPORTANTSSIMO
  //ds1307setup();        // Se for a primeira vez que o RTC  iniciado/ligado esta chamada  necessria para o RTC comear a contar
  // LCD - Defenir os cinco pins como pins de output
  pinMode(SCE, OUTPUT);
  pinMode(RES, OUTPUT);
  pinMode(DC, OUTPUT);
  pinMode(SDI, OUTPUT);
  pinMode(SCK, OUTPUT); 
  initlcd();    // Iniciar o LCD
  delay(100);   // O datasheet pede 100ms aps arrancar
}

void loop(){
  printData();
  delay(1000);
  
}

void printData(){
  int rtc[7];
  ds1307get(rtc,true);
  Serial.print("Sao:    ");
  int horas = rtc[HORAS];             //Coloca as horas numa variavel
  Serial.print(horas,DEC);            // em primeiro vm as horas...
  Serial.print(":");                  // ...
  int minutos = rtc[MINUTOS];         //Coloca os segundos numa variavel
  Serial.print(minutos,DEC);          // Agora os minutos...
  Serial.print(":");                  // ...
  int segundos = rtc[SEGUNDOS];       //Coloca os segundos numa variavel
  Serial.print(segundos,DEC);         // E de seguida os segundos. Vamos agora s estrelas... (Ai Marisa... (.)(.) )
  char hor_str[3] = "  ";             //criamos uma string onde vamos colocar o valor das horas
  char min_str[3] = "  ";             //criamos uma string onde vamos colocar o valor dos minutos
  char seg_str[3] = "  ";             //criamos uma string onde vamos colocar o valor dos segundos
  itoa(horas, hor_str, 10);           //Convertemos de inteiro (horas) para string(hor_str) na base 10, decimal.
  itoa(minutos, min_str, 10);         //Convertemos de inteiro (minutos) para string(min_str) na base 10, decimal.
  itoa(segundos, seg_str, 10);        //Convertemos de inteiro (segundos) para string(seg_str) na base 10, decimal.
  cursorxy(0,1);                      //Posicionamos o cursor no lcd.
  apagarLinha(1);                     // Apaga uma linha do LCD.
  cursorxy(0,1);                      //Posicionamos novamente o cursor no lcd.
  putstr(hor_str);                    //Colocamos os segundos no LCD :)
  putstr(":");
  putstr(min_str);                    //Colocamos os segundos no LCD :)
  putstr(":"); 
  putstr(seg_str);                    //Colocamos os segundos no LCD :)
 
  // Um textito para ficar bonito quando se mostra  famlia!
  switch(rtc[DIASEMANA]){
    case 0:Serial.print("   Domingo"); break;        //para mim a semana comea ao Domingo :P
    case 1:Serial.print("   Segunda-feira"); break;
    case 2:Serial.print("   Tera-feira"); break;
    case 3:Serial.print("   Quarta-feira"); break;
    case 4:Serial.print("   Quinta-feira"); break;
    case 5:Serial.print("   Sexta-feira"); break;
    case 6:Serial.print("   Sabado"); break;
    default:Serial.print("   DiaDeSaoNunca-feira");  //Se vier aqui... aguentem :D  feriado! Ahaha
  }
  Serial.print(" dia ");
  Serial.print(rtc[DIAMES]);  // Este  o dia do mes caso no d para entender XD, no fao tratamento dos dias por isso pode dar dia 0 ou 9999
  Serial.print(" de");
    switch(rtc[MES]){
    case 0:Serial.print(" Janeiro"); break;      
    case 1:Serial.print(" Fevereiro"); break;
    case 2:Serial.print(" Marco"); break;
    case 3:Serial.print(" Abril"); break;
    case 4:Serial.print(" Maio"); break;
    case 5:Serial.print(" Junho"); break;
    case 6:Serial.print(" Julho"); break;
    case 7:Serial.print(" Agosto"); break;
    case 8:Serial.print(" Setembro"); break;
    case 9:Serial.print(" Outubro"); break;
    case 10:Serial.print(" Novembro"); break;
    case 11:Serial.print(" Dezembro"); break;
    default:Serial.print(" Oufevulhosto");  //Se vier aqui...  aquele 13 ms vamos receber mais $ :D! 
  }
  Serial.print(" de ");
  Serial.println(rtc[ANO],DEC);  // Yaeih acabou! 
}
