//-------Rotinas para pcd8544 por Daniel Gonalves a.k.a. Tr3s------
// Podem usar estas rotinas  vontade para projectos particulares. 
// Para fins comerciais entrar em contacto com we_real_cool@hotmail.com
// Partilhem com apenas com o meu concentimento. 
// Se virem este cdigo noutro sitio sem ser www.lusorobotica.com avisem de imediato para we_real_cool@hotmail.com!

byte nokiabyte[11][5] = {
{0x3e, 0x51, 0x49, 0x45, 0x3e} // 30 0
,{0x00, 0x42, 0x7f, 0x40, 0x00} // 31 1
,{0x42, 0x61, 0x51, 0x49, 0x46} // 32 2
,{0x21, 0x41, 0x45, 0x4b, 0x31} // 33 3
,{0x18, 0x14, 0x12, 0x7f, 0x10} // 34 4
,{0x27, 0x45, 0x45, 0x45, 0x39} // 35 5
,{0x3c, 0x4a, 0x49, 0x49, 0x30} // 36 6
,{0x01, 0x71, 0x09, 0x05, 0x03} // 37 7
,{0x36, 0x49, 0x49, 0x49, 0x36} // 38 8
,{0x06, 0x49, 0x49, 0x29, 0x1e} // 39 9
,{0x00, 0x36, 0x36, 0x00, 0x00} // 3a :
};

void initlcd(void){        // Iniciar o LCD, tem de se usar isto antes de fazer qualquer coisa no LCD! Se no se defenir a tenso do LCD este pode queimar.
  digitalWrite(RES, HIGH); // Meter o pin reset a 1
  digitalWrite(SCE, HIGH); // Desactivar o chip
  digitalWrite(RES, LOW);  // Fazer reset ao LCD
  delay(100);              // Conforme diz no datasheet do pcd8544, convem esperar 100ms ate o poder acordar
  digitalWrite(RES, HIGH); // Acordar o LCD do estado RESET
  
  writecom(0x21); // Activar o chip e H=1 (datasheet)
  writecom(0xC2); // Defenir a voltagem/tenso do LCD para 7V
  writecom(0x13); // Ajusta a zona de operao/"Bias point" com base na voltagem defenida
  writecom(0x20); // Define o modo de operao, neste caso endereamento Horizontal (H=0)
  writecom(0x09); // Acticar todos os segmentos
  clearram();     // Limpar a memria ram
  writecom(0x08); // Limpar/flashar o ecra
  writecom(0x0C); // Normalizar o ecra
  cursorxy(0, 0); // Colocar o cursor na primeira coluna da primeira linha do ecra
}

void writecom(char command_in){  // Esta rotina, agora um mtodo, serve para enviar comandos para o controlador do LCD, desligar, inverter pixeis, tipo de endereamento, etc.
  digitalWrite(DC, LOW);         // Seleccionar o registo de Comandos
  digitalWrite(SCE, LOW);        // Seleccionar o chip
  clockdata(command_in);         // Enviar os bits de comando a cada clock,ou "clock in" aos bits de comando
  digitalWrite(SCE, HIGH);       // Libertar o chip
}

void writedata(char data_in){   // Com esta rotina, agora mtodo, envia-se um byte para o LCD, este byte corresponde a uma coluna com um pixel de largura e 8 pixeis de altura (1x8), 0xFF coluna toda a negro
  digitalWrite(DC, HIGH);       // Seleccionar o registo de Dados
  digitalWrite(SCE, LOW);       // Seleccionar o chip
  clockdata(data_in);           // "Clock in" :) os bits de dados
  digitalWrite(SCE, HIGH);      // Libertar o chip
}

void clockdata(char bits_in){                              // Esta rotina envia os dados para o PCD8544
  char bitcnt;
  for (bitcnt = 8; bitcnt > 0; bitcnt--){
    digitalWrite(SCK, LOW);                                // Parar o clock
    if ((bits_in & 0x80) == 0x80) digitalWrite(SDI, HIGH); // O pcd8544 "clock in" o MSB primeiro
    else digitalWrite(SDI, LOW); 
    digitalWrite(SCK, HIGH);                               // Os dados sao enviados nas transies ascendentes de clock
    bits_in <<= 1;                                         // Menos um bit, shift tudo 1bit
  }
}

void clearram(void){                   // PCD8544 - Limpa a RAM do controlador PCD8544 e assim limpa-se o LCD.
  int ddram;
  cursorxy(0, 0);                        // Colocar o cursor no inicio do ecr
  for (ddram = 504; ddram > 0; ddram--){ // 6(linhas) x 84 (colunas) = 504 endereos
    writedata(0x00);
  }
}

void apagarLinha(int linha){                   // PCD8544 - Limpa a RAM do controlador PCD8544 e assim limpa-se o LCD.
  cursorxy(0, linha);                          // Colocar o cursor no inicio da linha.
  for (int i = 0; i < 84; i++){                // 84 (colunas)
    writedata(0x00);
  }
}


/*void clearram(void){                   // OM6206 - Limpa a RAM do controlador OM6206 e assim limpa-se o LCD.
  int ddram;
  cursorxy(0, 0);                        // Colocar o cursor no inicio do ecr
  for (ddram = 864; ddram > 0; ddram--){ // 9(linhas) x 96 (colunas) = 864 endereos
    writedata(0x00);
  }
}*/

/*void cursorxy(char x,char y){ // PCD8544 - Colocar o cursor em determinada linha e coluna. Ex.: cursorxy(24,3) -> os proximos dados irao comear a aparecer na linha 3 e coluna 24
  writecom(0x40 | (y & 0x07));  // definir cursor no eixo OY
  writecom(0x80 | (x & 0x7F));  // definir cursor no eixo OX
}*/

void cursorxy(char x,char y){   // OM6206 - Colocar o cursor em determinada linha e coluna. Ex.: cursorxy(24,3) -> os proximos dados irao comear a aparecer na linha 3 e coluna 24
  writecom(0x40 | (y & 0x0F));  // definir cursor no eixo OY
  writecom(0x80 | (x & 0x7F));  // definir cursor no eixo OX
}

void putchar(char character){                  // Traduz os caracteres para um formato reconhecido pelo PCD8544 e envia-os para o LCD. Cada caracter  um conjunto de 5 bytes.
  for (char i = 0; i < 5; i++){
    writedata(nokiabyte[character - 0x30][i]); // Vai buscar o byte ao array de caracteres e envia-o para o LCD
  }
  writedata(0x00);                             // Espaamento de um pixel entre cada caracter
}

void putcharInv(char character){                  // Traduz os caracteres para um formato reconhecido pelo PCD8544 e envia-os para o LCD. Cada caracter  um conjunto de 5 bytes.
  for (char i = 0; i < 5; i++){
    writedata((nokiabyte[character - 0x30][i])^0xff); // Vai buscar o byte ao array de caracteres e envia-o para o LCD com as cores inversas
  }
  writedata(0xff);                             // Espaamento de um pixel entre cada caracter
}

void putstr(const char *s){  // Colocar uma frase/conjunto de caracteres (String) no LCD.
  while(*s){putchar(*s++);}  // Apontar para um caracter no formato ASCII e escrever um caracter de cada vez
}

void putstrInv(const char *s){  // Colocar uma frase/conjunto de caracteres (String) no LCD com as cores inversas.
  while(*s){putcharInv(*s++);}  // Apontar para um caracter no formato ASCII e escrever um caracter de cada vez
}

// Por Daniel Gonalves a.k.a. (t.c.p.) Tr3s, para www.lusorobotica.com
// Jos Xavier @ metRo_ :: Todo o trabalho foi feito por Daniel Gonalves a.k.a. (t.c.p.) Tr3s s acrescentei as funes apagarLinha,putcharInv e putstrInv.
